unit uOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, IniFiles, Spin, uConst, uFunc, sSkinProvider,
  sSpinEdit, sButton, sEdit, sLabel, sCheckBox;

type
  TfrmOptions = class(TForm)
    eChannel: TEdit;
    bOK: TButton;
    bCancel: TButton;
    lPaintChannel: TLabel;
    lPluginName: TLabel;
    lRestartPlugin: TLabel;
    eBotName: TEdit;
    lBotPass: TLabel;
    eBotPass: TEdit;
    lBotIP: TLabel;
    eBotIP: TEdit;
    cbBotMale: TComboBox;
    lMale: TLabel;
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    FOptions : TOptions;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOptions: TfrmOptions;

implementation

{$R *.dfm}

procedure TfrmOptions.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult = mrOk then
    begin
      FOptions.PaintChannel := Trim(LowerCase(eChannel.Text));
      FOptions.BotName      := Trim(eBotName.Text);
      FOptions.BotPassword  := Trim(eBotPass.Text);
      FOptions.BotIP        := Trim(eBotIP.Text);
      FOptions.BotIsMale   := cbBotMale.ItemIndex = 0;
      if (Length(FOptions.PaintChannel) = 0) or
         (Length(FOptions.BotName) = 0) or
         (Length(FOptions.BotIP) = 0) or
         (Length(FOptions.BotPassword) = 0) then
        begin
          ShowMessage('   ');
          CanClose := False;
        end;
    end;
end;

procedure TfrmOptions.OnClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult = mrOk then
    SaveOptionsToFile(FOptions);
end;

procedure TfrmOptions.OnShow(Sender: TObject);
begin
  LoadOptionsFromFile(FOptions);
  eChannel.Text := FOptions.PaintChannel;
  eBotName.Text := FOptions.BotName;
  eBotPass.Text := FOptions.BotPassword;
  eBotIP.Text   := FOptions.BotIP;
  cbBotMale.ItemIndex := Integer(not FOptions.BotIsMale);
end;

end.

