unit uPlugin;

interface

uses Windows, Classes, SysUtils, Dialogs, uFunc, uConst, Generics.Collections;


function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; cdecl; stdcall;
procedure PluginStop(); cdecl; stdcall;
procedure PluginShowOptions(); cdecl; stdcall;
procedure PluginShowAbout(); cdecl; stdcall;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD); cdecl; stdcall;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
            dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; cdecl; stdcall;
//function  PluginPremoderation(dwID : DWORD; wText : PWideChar; var dwTextLength : DWORD): Integer; cdecl; stdcall;

 procedure ppVuserLoginFail(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
 procedure ppUserEnterChat(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
 procedure ppVUserJoinChannelFail(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
 procedure ppUserJoinChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
 procedure ppVUserJoinChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
 procedure ppMsgInChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);

exports PluginStart, PluginStop, PluginProcess, PluginGetData, PluginShowOptions, PluginShowAbout{, PluginPremoderation};

implementation

uses uOptions;
var PluginStarted : Boolean = False;
    PaintDataEntryList : TList<TPaintDataEntry> = nil;
    DataCounter : Integer = -1;
//---------------------------------------------------------------------------
function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;
begin
	dwPluginID := dwThisPluginID;
	CommFortProcess := func1;
	CommFortGetData := func2;
  try
    //  
    LoadOptionsFromFile(Options);
    //  
    CreateVirtualUser(Options.BotName, Options.BotIP, Options.BotPassword, Options.BotIsMale);
    Result := Integer(TRUE);
    PluginStarted := True;
    PaintDataEntryList := TList<TPaintDataEntry>.Create();
  except
    on E : Exception do
      begin
        Result := Integer(False);
        ShowMessage('PluginStart() ' + E.Message);
      end;
  end;
end;
//---------------------------------------------------------------------------
procedure PluginStop();
begin
  PluginStarted := False;
  try
    DisconnectVirtualUser(Options.BotName);
    FreeAndNil(PaintDataEntryList);
  except
     on E : Exception do
       ShowMessage('PluginStop() ' + E.Message);
  end;
end;
//---------------------------------------------------------------------------
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset, iSenderIcon, iMessageMode : Integer;
    aDataToSend : AnsiString;
    uVirtualUserLogin, uSenderLogin, uSenderIP, uChannel, uText : WideString;
    {$IFDEF DEBUG}FileStream : TFileStream;{$ENDIF}
begin
  {$IFDEF DEBUG}
   FileStream := TFileStream.Create('D:\surbin.bin', fmOpenReadWrite or fmShareDenyNone);
   try
     FileStream.Position := FileStream.Size;
     FileStream.Write(#13#10, 2);
     FileStream.Write(bInBuffer^, dwInBufferSize);
   finally
     FileStream.Free();
   end;
  {$ENDIF}
  case dwID of
    PP_VUSER_LOGIN_FAIL            : ppVuserLoginFail(bInBuffer,  dwInBufferSize);
    PP_USER_ENTER_CHAT             : ppUserEnterChat(bInBuffer,  dwInBufferSize);
    PP_VUSER_JOIN_CHANNEL_FAIL     : ppVUserJoinChannelFail(bInBuffer,  dwInBufferSize);
    PP_USER_JOIN_CHANNEL           : ppUserJoinChannel(bInBuffer,  dwInBufferSize);
    PP_VUSER_JOIN_CHANNEL          : ppVUserJoinChannel(bInBuffer,  dwInBufferSize);
    PP_USER_MSG_IN_CHANNEL         : ppMsgInChannel(bInBuffer,  dwInBufferSize);
  end;
end;
//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;
var iWriteOffset, iSize : Integer;
    uName : WideString;
begin
	iWriteOffset := 0;
	if (dwID = 2800) then // 
	begin
		if (dwOutBufferSize = 0) then
			Result := 4 //   ,    
		else
		begin
			fWriteInteger(bOutBuffer, iWriteOffset, 1); //    
			Result := 4;//    
		end;
	end
	else
	if (dwID = 2810) then //  (  )
	begin
		uName := 'PaintBot';// 
		iSize := Length(uName) * 2 + 4;

		if (dwOutBufferSize = 0) then
			Result := iSize //   ,    
		else
		begin
			fWriteText(bOutBuffer, iWriteOffset, uName);
			Result := iSize;//    
		end;
	end
	else
		Result := 0;//  -   
end;

procedure ppVuserLoginFail(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var UserName : String;
    FailCode : Integer;
    FailMessage : String;
    iReadOffSet : Integer;
begin
  iReadOffSet := 0;
  UserName := fReadText(bInBuffer, iReadOffset);
  FailCode := fReadInteger(bInBuffer, iReadOffset);
  case FailCode of
    0: FailMessage := '    ';
    1: FailMessage := '    (  ,      40 )';
    2: FailMessage := '       ()';
    3: FailMessage := '    (    )';
    4: FailMessage := '     ';
    5: FailMessage := '       IP-';
    6: FailMessage := '    ';
    7: FailMessage := ' ';
    8: FailMessage := '    ,  ';
  end;
  ShowMessage(
    Format('PaintBot Plugin.' +#13#10+
           '    : "%s"' + #13#10 +
           ' - %s', [UserName, FailMessage]));
end;

procedure ppUserEnterChat(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var UserName : String;
    iReadOffSet : Integer;
begin
  iReadOffSet := 0;
  UserName := fReadText(bInBuffer, iReadOffset);
  if UserName = Options.BotName then
    CreateOrEnterChannel(Options.BotName, Options.PaintChannel);
end;

procedure ppVUserJoinChannelFail(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var UserName : String;
    ChannelName : String;
    FailCode : Integer;
    FailMessage : String;
    iReadOffSet : Integer;
begin
  iReadOffSet := 0;

  UserName := fReadText(bInBuffer, iReadOffset);
  ChannelName := fReadText(bInBuffer, iReadOffset);
  if ChannelName <> Options.PaintChannel then
    Exit;
  FailCode := fReadInteger(bInBuffer, iReadOffset);
  case FailCode of
    0: FailMessage := '       ';
    1: FailMessage := '    ' + #13#10 +
      '(  ,      32 )';
  end;
  ShowMessage('PaintBot Plugin.'+#13#10+
    Format('    : "%s"' + #13#10 +
           '  : "%s"' + #13#10 +
           ' - %s', [UserName, ChannelName, FailMessage]));
end;

procedure ppUserJoinChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var VUserName, UserName : String;
    ChannelName : String;
    iReadOffSet : Integer;
    sDataToSend : String;
    i : Integer;
    sImageLimitation : TSize;
begin
//  try
    iReadOffSet := 0;
    VUserName := fReadText(bInBuffer, iReadOffset);
    ChannelName := fReadText(bInBuffer, iReadOffset);
    UserName := fReadText(bInBuffer, iReadOffset);

    if (VUserName = Options.BotName) and (ChannelName = Options.PaintChannel) and
     (UserName <> Options.BotName) then
    begin
      ClearPaintDataIfNeed(PaintDataEntryList);
      if PaintDataEntryList.Count = 0 then
        Exit;
      sImageLimitation := GetImageLimitation('&priv');
      if Options.SavePictures and (sImageLimitation.cy > 0) then
      begin

      end
      else
      begin
        SetLength(sDataToSend, 0);
        for i := 0 to PaintDataEntryList.Count - 1 do
        if (not PaintDataEntryList[i].IsPicture) and
           (PaintDataEntryList[i].PaintData[1] <> 'I') then
          sDataToSend := sDataToSend + PaintDataEntryList[i].PaintData + #9;
        SetLength(sDataToSend, Length(sDataToSend) - 1);
        if Length(sDataToSend) > 0 then
          MsgToPrivatChannel(VUserName, UserName, START_PAINT_MESSAGE + sDataToSend + END_PAINT_MESSAGE);
      end;
    end;
//  except
//    on E : Exception do
//      ShowMessage(E.Message +  ' ppUserJoinChannel()');
//  end;
end;

procedure ppVUserJoinChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var UserName : String;
    ChannelName : String;
    iReadOffSet : Integer;
begin
  iReadOffSet := 0;
  UserName := fReadText(bInBuffer, iReadOffset);
  ChannelName := fReadText(bInBuffer, iReadOffset);
  if (UserName = Options.BotName) and
     (ChannelName <> Options.PaintChannel) then
    LeaveChannel(UserName, ChannelName);
end;

procedure ppMsgInChannel(bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var VUserName, UserName : String;
    ChannelName : String;
    iReadOffSet : Integer;
    MsgMode : Integer;
    TextDataStr : String;

    imgsize : TSize;
    pdeCurrentData : TPaintDataEntry;
begin
  iReadOffSet := 0;
  VUserName := fReadText(bInBuffer, iReadOffset);
  if VUserName <> Options.BotName then
    Exit;
  UserName := fReadText(bInBuffer, iReadOffset);
  if UserName = Options.BotName then
    Exit;
  fReadText(bInBuffer, iReadOffset); //ip
  fReadInteger(bInBuffer, iReadOffset); //icon
  ChannelName := fReadText(bInBuffer, iReadOffset);

//   bytes: 0, pixels: 0
//   bytes: 18000, pixels: 30000
//   bytes: 30000, pixels: 60000
//   bytes: 50000, pixels: 125000
//   bytes: 90000, pixels: 250000

//  {$IFDEF DEBUG}
//  imgsize := GetImageLimitation('&priv');
//  MsgToPrivatChannel(VUserName, UserName, Format('bytes: %d, pixels: %d', [imgsize.cx, imgsize.cy]));
//  {$ENDIF}
  if ChannelName <> Options.PaintChannel then
    Exit;
  MsgMode := fReadInteger(bInBuffer, iReadOffset);
  if MsgMode = 0 then
  begin
    TextDataStr := fReadText(bInBuffer, iReadOffset);
    if ExtractPaintDataString(TextDataStr) then
    begin
      PaintDataEntryList.Add(TextDataStr);
    end;
  end;
  if Options.SavePictures and (iReadOffSet < dwInBufferSize) then
  begin
    pdeCurrentData.PaintData := fReadText(bInBuffer, iReadOffSet);
    if Length(pdeCurrentData.PaintData) > 0 then
    begin
      pdeCurrentData.PaintDataByteCount := Length(pdeCurrentData.PaintData) * 2;
      pdeCurrentData.PaintDataPixelCount :=
        GetImagePixelCount(PAnsiChar(pdeCurrentData.PaintData), pdeCurrentData.PaintDataByteCount);
    end;
  end;
end;

//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
  if not PluginStarted then
    ShowMessage('     ')
  else
    begin
      frmOptions := TfrmOptions.Create(nil);
      try
        frmOptions.ShowModal;
      finally
        FreeAndNil(frmOptions);
      end;
    end;
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
  ShowMessage('CommFort PaintBot Plugin'#13#10'Copyright  2010 by -=SJ=-');
end;

initialization

end.

