unit uAbout;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, sSkinManager, sLabel, sPanel,
  sButton, sSkinProvider, StdCtrls, jpeg;

type
  TfmAbout = class(TForm)
    Image1: TImage;
    Label1: TsLabel;
    bDownloadUpdate: TsButton;
    bClose: TsButton;
    Panel1: TsPanel;
    sSkinManagerAB: TsSkinManager;
    sLabelFX1: TsLabelFX;
    sWebLabel1: TsWebLabel;
    sSkinProvider1: TsSkinProvider;
    sLabelFX2: TsLabelFX;
    tmShowAbout: TTimer;
    sLabel2: TsLabel;
    sLabel3: TsLabel;
    sLabel4: TsLabel;
    bCopyWMZ: TsButton;
    bCopyWMU: TsButton;
    bCopyWMR: TsButton;
    procedure FormCreate(Sender: TObject);
    procedure tmShowAboutTimer(Sender: TObject);
    procedure bDownloadUpdateClick(Sender: TObject);
    procedure bCopyWMZClick(Sender: TObject);
    procedure bCopyWMUClick(Sender: TObject);
    procedure bCopyWMRClick(Sender: TObject);
  private
    procedure SetShowExpiredInformation(const Value: Boolean);
    { Private declarations }
  public
    { Public declarations }
    property ShowExpiredInformation : Boolean write SetShowExpiredInformation;
    procedure ShowModalTimered();
  end;

var
  fmAbout: TfmAbout;

implementation

{$R *.dfm}
uses uFunc, DateUtils, Math, uConst, Clipbrd;

procedure TfmAbout.bCopyWMRClick(Sender: TObject);
begin
  Clipboard.SetTextBuf('R378148984922');
end;

procedure TfmAbout.bCopyWMUClick(Sender: TObject);
begin
  Clipboard.SetTextBuf('U230961756432');
end;

procedure TfmAbout.bCopyWMZClick(Sender: TObject);
begin
  Clipboard.SetTextBuf('Z305402177262');
end;

procedure TfmAbout.bDownloadUpdateClick(Sender: TObject);
begin
  OpenUrlInDefaultBrowser(URL_FOR_PLUGIN_UPDATE);
end;

procedure TfmAbout.FormCreate(Sender: TObject);
begin
  try
    inherited;
    sSkinManagerAB.Active := True;
    sSkinProvider1.SkinData.SkinManager := sSkinManagerAB;
    Panel1.SkinData.SkinManager := sSkinManagerAB;
    bDownloadUpdate.SkinData.SkinManager :=  sSkinManagerAB;
    bClose.SkinData.SkinManager :=  sSkinManagerAB;
    sSkinManagerAB.UpdateSkin();
    sLabelFX1.Caption := 'version: ' + PlugVersion();
    Label1.Caption := Format(Label1.Caption, [Max(2010, YearOf(Today()))]);
    sLabelFX2.Caption := Format(sLabelFX2.Caption, [CHAT_NAME]);
    ShowExpiredInformation := False;

  except
//     on E : Exception do
//       AddLogStr(E.Message, 'TfmAbout.FormCreate()');
  end;
end;
procedure TfmAbout.SetShowExpiredInformation(const Value: Boolean);
begin
  bDownloadUpdate.Visible := Value;
//  if Value then
//    begin
//
//    end
//  else
//    be
end;

procedure TfmAbout.ShowModalTimered;
begin
  tmShowAbout.Enabled := True;
end;

procedure TfmAbout.tmShowAboutTimer(Sender: TObject);
begin
  tmShowAbout.Enabled := False;
  try
    Self.ShowModal();
  finally
    FreeAndNilA(fmAbout);
  end;
end;

end.
