unit uOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, uFunc,
  sHintManager, uConst, ExtCtrls;

type
  TfrmOptions = class(TForm)
    eChannel: TEdit;
    bOK: TButton;
    bCancel: TButton;
    sLabel1: TLabel;
    ePrompterName: TEdit;
    sLabel3: TLabel;
    tmShowOptions: TTimer;
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tmShowOptionsTimer(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ShowModalTimered();
  end;
//  TOptions = record
//    PaintChannel : String;
//    PrompterName : String;
//  end;

var
  frmOptions: TfrmOptions;
//  Options : TOptions;

implementation

{$R *.dfm}

procedure TfrmOptions.OnShow(Sender: TObject);
begin
  eChannel.Text := MemIniFile.ReadString('GeneralSettings', 'PaintChannel', 'paintboard');
  {$IFNDEF VTALKING}
  ePrompterName.Text := MemIniFile.ReadString('GeneralSettings', 'PaintPrompterName', 'PaintBot');
  {$ELSE}
  sLabel3.Visible := False;
  ePrompterName.Visible := False;
  Self.Height := Self.Height - (ePrompterName.Top - sLabel3.Top + ePrompterName.Height);
  {$ENDIF}
end;

procedure TfrmOptions.ShowModalTimered;
begin
  tmShowOptions.Enabled := True;
end;

procedure TfrmOptions.tmShowOptionsTimer(Sender: TObject);
begin
  tmShowOptions.Enabled := False;
  try
    Self.ShowModal();
  finally
    FreeAndNilA(frmOptions);
  end;
end;


procedure TfrmOptions.FormCreate(Sender: TObject);
begin
  Self.Caption := Format(Self.Caption, [CHAT_NAME]);
end;

procedure TfrmOptions.OnClose(Sender: TObject; var Action: TCloseAction);
begin
  if ModalResult = mrOk then
  begin
    MemIniFile.WriteString('GeneralSettings', 'PaintChannel', Trim(eChannel.Text));
    {$IFNDEF VTALKING}
    MemIniFile.WriteString('GeneralSettings', 'PaintPrompterName', Trim(ePrompterName.Text));
    {$ENDIF}
  end;
end;


end.
